/**
 *  Copyright (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  Licensed under the GPL, Version 3.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/gpl.html
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * --------------------------------------------------------------------------
 *  版权 (c) 1997-2013, tinygroup.org (luo_guo@live.cn).
 *
 *  本开源软件遵循 GPL 3.0 协议;
 *  如果您不遵循此协议，则不被允许使用此文件。
 *  你可以从下面的地址获取完整的协议文本
 *
 *       http://www.gnu.org/licenses/gpl.html
 */
package org.tinygroup.tinydb.operator;

import org.tinygroup.tinydb.Bean;
import org.tinygroup.tinydb.order.OrderBean;
import org.tinygroup.tinydb.query.QueryBean;
import org.tinygroup.tinydb.select.SelectBean;

/**
 * DB相关的查询操作
 * 
 * @author luoguo
 * 
 */
public interface DbSqlQueryOperator<KeyType> {

	/**
	 * 根据查询对象获取数据
	 * @param queryBean
	 *            查询条件
	 * @param sql
	 *            SQL语句
	 * 
	 * @return
	 */
	Bean[] getBeans(SelectBean[] selectBeans, QueryBean queryBean,
			OrderBean[] orderBeans);
	
	Bean[] getBeans(QueryBean queryBean,
			OrderBean[] orderBeans);

	Bean[] getBeans(SelectBean[] selectBeans, QueryBean queryBean,
			OrderBean[] orderBeans, int start, int limit);
	
	Bean[] getBeans(QueryBean queryBean,
			OrderBean[] orderBeans, int start, int limit);
	
	<T> T getSingleValue(QueryBean queryBean);
	
	<T> T getSingleValue(SelectBean[] selectBeans, QueryBean queryBean);

	Bean[] getBeans(String selectClause, QueryBean queryBean,
			OrderBean[] orderBeans);

	Bean[] getBeans(String selectClause, QueryBean queryBean,
			OrderBean[] orderBeans, int start, int limit);

	<T> T getSingleValue(String selectClause, QueryBean queryBean);
}
